require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS__CSAN_ATOMIC_H_)) {
    eval 'sub _SYS__CSAN_ATOMIC_H_ () {1;}' unless defined(&_SYS__CSAN_ATOMIC_H_);
    unless(defined(&_MACHINE_ATOMIC_H_)) {
	die("do\ not\ include\ this\ header\,\ use\ machine\/atomic\.h");
    }
    eval 'sub KCSAN_ATOMIC_FUNC_1 {
        my($op, $name, $type) = @_;
	    eval q( &void  &kcsan_atomic_$op &_$name( &volatile $type *, $type);  &void  &kcsan_atomic_$op &_acq_$name( &volatile $type *, $type);  &void  &kcsan_atomic_$op &_rel_$name( &volatile $type *, $type));
    }' unless defined(&KCSAN_ATOMIC_FUNC_1);
    eval 'sub KCSAN_ATOMIC_CMPSET {
        my($name, $type) = @_;
	    eval q(\'int\'  &kcsan_atomic_cmpset_$name( &volatile $type *, $type, $type); \'int\'  &kcsan_atomic_cmpset_acq_$name( &volatile $type *, $type, $type); \'int\'  &kcsan_atomic_cmpset_rel_$name( &volatile $type *, $type, $type));
    }' unless defined(&KCSAN_ATOMIC_CMPSET);
    eval 'sub KCSAN_ATOMIC_FCMPSET {
        my($name, $type) = @_;
	    eval q(\'int\'  &kcsan_atomic_fcmpset_$name( &volatile $type *, $type *, $type); \'int\'  &kcsan_atomic_fcmpset_acq_$name( &volatile $type *, $type *, $type); \'int\'  &kcsan_atomic_fcmpset_rel_$name( &volatile $type *, $type *, $type));
    }' unless defined(&KCSAN_ATOMIC_FCMPSET);
    eval 'sub KCSAN_ATOMIC_READ {
        my($op, $name, $type) = @_;
	    eval q($type  &kcsan_atomic_$op &_$name( &volatile $type *, $type));
    }' unless defined(&KCSAN_ATOMIC_READ);
    eval 'sub KCSAN_ATOMIC_READANDCLEAR {
        my($name, $type) = @_;
	    eval q($type  &kcsan_atomic_readandclear_$name( &volatile $type *));
    }' unless defined(&KCSAN_ATOMIC_READANDCLEAR);
    eval 'sub KCSAN_ATOMIC_LOAD {
        my($name, $type) = @_;
	    eval q($type  &kcsan_atomic_load_$name( &volatile $type *); $type  &kcsan_atomic_load_acq_$name( &volatile $type *));
    }' unless defined(&KCSAN_ATOMIC_LOAD);
    eval 'sub KCSAN_ATOMIC_STORE {
        my($name, $type) = @_;
	    eval q( &void  &kcsan_atomic_store_$name( &volatile $type *, $type);  &void  &kcsan_atomic_store_rel_$name( &volatile $type *, $type));
    }' unless defined(&KCSAN_ATOMIC_STORE);
    eval 'sub KCSAN_ATOMIC_TEST {
        my($op, $name, $type) = @_;
	    eval q(\'int\'  &kcsan_atomic_$op &_$name( &volatile $type *, \'u_int\'); \'int\'  &kcsan_atomic_$op &_acq_$name( &volatile $type *, \'u_int\'));
    }' unless defined(&KCSAN_ATOMIC_TEST);
    eval 'sub KCSAN_ATOMIC_FUNCS {
        my($name, $type) = @_;
	    eval q( &KCSAN_ATOMIC_FUNC_1( &add, $name, $type);  &KCSAN_ATOMIC_FUNC_1( &clear, $name, $type);  &KCSAN_ATOMIC_CMPSET($name, $type);  &KCSAN_ATOMIC_FCMPSET($name, $type);  &KCSAN_ATOMIC_READ( &fetchadd, $name, $type);  &KCSAN_ATOMIC_LOAD($name, $type);  &KCSAN_ATOMIC_READANDCLEAR($name, $type);  &KCSAN_ATOMIC_FUNC_1( &set, $name, $type);  &KCSAN_ATOMIC_FUNC_1( &subtract, $name, $type);  &KCSAN_ATOMIC_STORE($name, $type);  &KCSAN_ATOMIC_READ( &swap, $name, $type);  &KCSAN_ATOMIC_TEST( &testandclear, $name, $type);  &KCSAN_ATOMIC_TEST( &testandset, $name, $type));
    }' unless defined(&KCSAN_ATOMIC_FUNCS);
    unless(defined(&KCSAN_RUNTIME)) {
	eval 'sub atomic_add_char () { &kcsan_atomic_add_char;}' unless defined(&atomic_add_char);
	eval 'sub atomic_add_acq_char () { &kcsan_atomic_add_acq_char;}' unless defined(&atomic_add_acq_char);
	eval 'sub atomic_add_rel_char () { &kcsan_atomic_add_rel_char;}' unless defined(&atomic_add_rel_char);
	eval 'sub atomic_clear_char () { &kcsan_atomic_clear_char;}' unless defined(&atomic_clear_char);
	eval 'sub atomic_clear_acq_char () { &kcsan_atomic_clear_acq_char;}' unless defined(&atomic_clear_acq_char);
	eval 'sub atomic_clear_rel_char () { &kcsan_atomic_clear_rel_char;}' unless defined(&atomic_clear_rel_char);
	eval 'sub atomic_cmpset_char () { &kcsan_atomic_cmpset_char;}' unless defined(&atomic_cmpset_char);
	eval 'sub atomic_cmpset_acq_char () { &kcsan_atomic_cmpset_acq_char;}' unless defined(&atomic_cmpset_acq_char);
	eval 'sub atomic_cmpset_rel_char () { &kcsan_atomic_cmpset_rel_char;}' unless defined(&atomic_cmpset_rel_char);
	eval 'sub atomic_fcmpset_char () { &kcsan_atomic_fcmpset_char;}' unless defined(&atomic_fcmpset_char);
	eval 'sub atomic_fcmpset_acq_char () { &kcsan_atomic_fcmpset_acq_char;}' unless defined(&atomic_fcmpset_acq_char);
	eval 'sub atomic_fcmpset_rel_char () { &kcsan_atomic_fcmpset_rel_char;}' unless defined(&atomic_fcmpset_rel_char);
	eval 'sub atomic_fetchadd_char () { &kcsan_atomic_fetchadd_char;}' unless defined(&atomic_fetchadd_char);
	eval 'sub atomic_load_char () { &kcsan_atomic_load_char;}' unless defined(&atomic_load_char);
	eval 'sub atomic_load_acq_char () { &kcsan_atomic_load_acq_char;}' unless defined(&atomic_load_acq_char);
	eval 'sub atomic_readandclear_char () { &kcsan_atomic_readandclear_char;}' unless defined(&atomic_readandclear_char);
	eval 'sub atomic_set_char () { &kcsan_atomic_set_char;}' unless defined(&atomic_set_char);
	eval 'sub atomic_set_acq_char () { &kcsan_atomic_set_acq_char;}' unless defined(&atomic_set_acq_char);
	eval 'sub atomic_set_rel_char () { &kcsan_atomic_set_rel_char;}' unless defined(&atomic_set_rel_char);
	eval 'sub atomic_subtract_char () { &kcsan_atomic_subtract_char;}' unless defined(&atomic_subtract_char);
	eval 'sub atomic_subtract_acq_char () { &kcsan_atomic_subtract_acq_char;}' unless defined(&atomic_subtract_acq_char);
	eval 'sub atomic_subtract_rel_char () { &kcsan_atomic_subtract_rel_char;}' unless defined(&atomic_subtract_rel_char);
	eval 'sub atomic_store_char () { &kcsan_atomic_store_char;}' unless defined(&atomic_store_char);
	eval 'sub atomic_store_rel_char () { &kcsan_atomic_store_rel_char;}' unless defined(&atomic_store_rel_char);
	eval 'sub atomic_swap_char () { &kcsan_atomic_swap_char;}' unless defined(&atomic_swap_char);
	eval 'sub atomic_testandclear_char () { &kcsan_atomic_testandclear_char;}' unless defined(&atomic_testandclear_char);
	eval 'sub atomic_testandset_char () { &kcsan_atomic_testandset_char;}' unless defined(&atomic_testandset_char);
	eval 'sub atomic_add_short () {\'kcsan_atomic_add_short\';}' unless defined(&atomic_add_short);
	eval 'sub atomic_add_acq_short () {\'kcsan_atomic_add_acq_short\';}' unless defined(&atomic_add_acq_short);
	eval 'sub atomic_add_rel_short () {\'kcsan_atomic_add_rel_short\';}' unless defined(&atomic_add_rel_short);
	eval 'sub atomic_clear_short () {\'kcsan_atomic_clear_short\';}' unless defined(&atomic_clear_short);
	eval 'sub atomic_clear_acq_short () {\'kcsan_atomic_clear_acq_short\';}' unless defined(&atomic_clear_acq_short);
	eval 'sub atomic_clear_rel_short () {\'kcsan_atomic_clear_rel_short\';}' unless defined(&atomic_clear_rel_short);
	eval 'sub atomic_cmpset_short () {\'kcsan_atomic_cmpset_short\';}' unless defined(&atomic_cmpset_short);
	eval 'sub atomic_cmpset_acq_short () {\'kcsan_atomic_cmpset_acq_short\';}' unless defined(&atomic_cmpset_acq_short);
	eval 'sub atomic_cmpset_rel_short () {\'kcsan_atomic_cmpset_rel_short\';}' unless defined(&atomic_cmpset_rel_short);
	eval 'sub atomic_fcmpset_short () {\'kcsan_atomic_fcmpset_short\';}' unless defined(&atomic_fcmpset_short);
	eval 'sub atomic_fcmpset_acq_short () {\'kcsan_atomic_fcmpset_acq_short\';}' unless defined(&atomic_fcmpset_acq_short);
	eval 'sub atomic_fcmpset_rel_short () {\'kcsan_atomic_fcmpset_rel_short\';}' unless defined(&atomic_fcmpset_rel_short);
	eval 'sub atomic_fetchadd_short () {\'kcsan_atomic_fetchadd_short\';}' unless defined(&atomic_fetchadd_short);
	eval 'sub atomic_load_short () {\'kcsan_atomic_load_short\';}' unless defined(&atomic_load_short);
	eval 'sub atomic_load_acq_short () {\'kcsan_atomic_load_acq_short\';}' unless defined(&atomic_load_acq_short);
	eval 'sub atomic_readandclear_short () {\'kcsan_atomic_readandclear_short\';}' unless defined(&atomic_readandclear_short);
	eval 'sub atomic_set_short () {\'kcsan_atomic_set_short\';}' unless defined(&atomic_set_short);
	eval 'sub atomic_set_acq_short () {\'kcsan_atomic_set_acq_short\';}' unless defined(&atomic_set_acq_short);
	eval 'sub atomic_set_rel_short () {\'kcsan_atomic_set_rel_short\';}' unless defined(&atomic_set_rel_short);
	eval 'sub atomic_subtract_short () {\'kcsan_atomic_subtract_short\';}' unless defined(&atomic_subtract_short);
	eval 'sub atomic_subtract_acq_short () {\'kcsan_atomic_subtract_acq_short\';}' unless defined(&atomic_subtract_acq_short);
	eval 'sub atomic_subtract_rel_short () {\'kcsan_atomic_subtract_rel_short\';}' unless defined(&atomic_subtract_rel_short);
	eval 'sub atomic_store_short () {\'kcsan_atomic_store_short\';}' unless defined(&atomic_store_short);
	eval 'sub atomic_store_rel_short () {\'kcsan_atomic_store_rel_short\';}' unless defined(&atomic_store_rel_short);
	eval 'sub atomic_swap_short () {\'kcsan_atomic_swap_short\';}' unless defined(&atomic_swap_short);
	eval 'sub atomic_testandclear_short () {\'kcsan_atomic_testandclear_short\';}' unless defined(&atomic_testandclear_short);
	eval 'sub atomic_testandset_short () {\'kcsan_atomic_testandset_short\';}' unless defined(&atomic_testandset_short);
	eval 'sub atomic_add_int () { &kcsan_atomic_add_int;}' unless defined(&atomic_add_int);
	eval 'sub atomic_add_acq_int () { &kcsan_atomic_add_acq_int;}' unless defined(&atomic_add_acq_int);
	eval 'sub atomic_add_rel_int () { &kcsan_atomic_add_rel_int;}' unless defined(&atomic_add_rel_int);
	eval 'sub atomic_clear_int () { &kcsan_atomic_clear_int;}' unless defined(&atomic_clear_int);
	eval 'sub atomic_clear_acq_int () { &kcsan_atomic_clear_acq_int;}' unless defined(&atomic_clear_acq_int);
	eval 'sub atomic_clear_rel_int () { &kcsan_atomic_clear_rel_int;}' unless defined(&atomic_clear_rel_int);
	eval 'sub atomic_cmpset_int () { &kcsan_atomic_cmpset_int;}' unless defined(&atomic_cmpset_int);
	eval 'sub atomic_cmpset_acq_int () { &kcsan_atomic_cmpset_acq_int;}' unless defined(&atomic_cmpset_acq_int);
	eval 'sub atomic_cmpset_rel_int () { &kcsan_atomic_cmpset_rel_int;}' unless defined(&atomic_cmpset_rel_int);
	eval 'sub atomic_fcmpset_int () { &kcsan_atomic_fcmpset_int;}' unless defined(&atomic_fcmpset_int);
	eval 'sub atomic_fcmpset_acq_int () { &kcsan_atomic_fcmpset_acq_int;}' unless defined(&atomic_fcmpset_acq_int);
	eval 'sub atomic_fcmpset_rel_int () { &kcsan_atomic_fcmpset_rel_int;}' unless defined(&atomic_fcmpset_rel_int);
	eval 'sub atomic_fetchadd_int () { &kcsan_atomic_fetchadd_int;}' unless defined(&atomic_fetchadd_int);
	eval 'sub atomic_load_int () { &kcsan_atomic_load_int;}' unless defined(&atomic_load_int);
	eval 'sub atomic_load_acq_int () { &kcsan_atomic_load_acq_int;}' unless defined(&atomic_load_acq_int);
	eval 'sub atomic_readandclear_int () { &kcsan_atomic_readandclear_int;}' unless defined(&atomic_readandclear_int);
	eval 'sub atomic_set_int () { &kcsan_atomic_set_int;}' unless defined(&atomic_set_int);
	eval 'sub atomic_set_acq_int () { &kcsan_atomic_set_acq_int;}' unless defined(&atomic_set_acq_int);
	eval 'sub atomic_set_rel_int () { &kcsan_atomic_set_rel_int;}' unless defined(&atomic_set_rel_int);
	eval 'sub atomic_subtract_int () { &kcsan_atomic_subtract_int;}' unless defined(&atomic_subtract_int);
	eval 'sub atomic_subtract_acq_int () { &kcsan_atomic_subtract_acq_int;}' unless defined(&atomic_subtract_acq_int);
	eval 'sub atomic_subtract_rel_int () { &kcsan_atomic_subtract_rel_int;}' unless defined(&atomic_subtract_rel_int);
	eval 'sub atomic_store_int () { &kcsan_atomic_store_int;}' unless defined(&atomic_store_int);
	eval 'sub atomic_store_rel_int () { &kcsan_atomic_store_rel_int;}' unless defined(&atomic_store_rel_int);
	eval 'sub atomic_swap_int () { &kcsan_atomic_swap_int;}' unless defined(&atomic_swap_int);
	eval 'sub atomic_testandclear_int () { &kcsan_atomic_testandclear_int;}' unless defined(&atomic_testandclear_int);
	eval 'sub atomic_testandset_int () { &kcsan_atomic_testandset_int;}' unless defined(&atomic_testandset_int);
	eval 'sub atomic_add_long () {\'kcsan_atomic_add_long\';}' unless defined(&atomic_add_long);
	eval 'sub atomic_add_acq_long () {\'kcsan_atomic_add_acq_long\';}' unless defined(&atomic_add_acq_long);
	eval 'sub atomic_add_rel_long () {\'kcsan_atomic_add_rel_long\';}' unless defined(&atomic_add_rel_long);
	eval 'sub atomic_clear_long () {\'kcsan_atomic_clear_long\';}' unless defined(&atomic_clear_long);
	eval 'sub atomic_clear_acq_long () {\'kcsan_atomic_clear_acq_long\';}' unless defined(&atomic_clear_acq_long);
	eval 'sub atomic_clear_rel_long () {\'kcsan_atomic_clear_rel_long\';}' unless defined(&atomic_clear_rel_long);
	eval 'sub atomic_cmpset_long () {\'kcsan_atomic_cmpset_long\';}' unless defined(&atomic_cmpset_long);
	eval 'sub atomic_cmpset_acq_long () {\'kcsan_atomic_cmpset_acq_long\';}' unless defined(&atomic_cmpset_acq_long);
	eval 'sub atomic_cmpset_rel_long () {\'kcsan_atomic_cmpset_rel_long\';}' unless defined(&atomic_cmpset_rel_long);
	eval 'sub atomic_fcmpset_long () {\'kcsan_atomic_fcmpset_long\';}' unless defined(&atomic_fcmpset_long);
	eval 'sub atomic_fcmpset_acq_long () {\'kcsan_atomic_fcmpset_acq_long\';}' unless defined(&atomic_fcmpset_acq_long);
	eval 'sub atomic_fcmpset_rel_long () {\'kcsan_atomic_fcmpset_rel_long\';}' unless defined(&atomic_fcmpset_rel_long);
	eval 'sub atomic_fetchadd_long () {\'kcsan_atomic_fetchadd_long\';}' unless defined(&atomic_fetchadd_long);
	eval 'sub atomic_load_long () {\'kcsan_atomic_load_long\';}' unless defined(&atomic_load_long);
	eval 'sub atomic_load_acq_long () {\'kcsan_atomic_load_acq_long\';}' unless defined(&atomic_load_acq_long);
	eval 'sub atomic_readandclear_long () {\'kcsan_atomic_readandclear_long\';}' unless defined(&atomic_readandclear_long);
	eval 'sub atomic_set_long () {\'kcsan_atomic_set_long\';}' unless defined(&atomic_set_long);
	eval 'sub atomic_set_acq_long () {\'kcsan_atomic_set_acq_long\';}' unless defined(&atomic_set_acq_long);
	eval 'sub atomic_set_rel_long () {\'kcsan_atomic_set_rel_long\';}' unless defined(&atomic_set_rel_long);
	eval 'sub atomic_subtract_long () {\'kcsan_atomic_subtract_long\';}' unless defined(&atomic_subtract_long);
	eval 'sub atomic_subtract_acq_long () {\'kcsan_atomic_subtract_acq_long\';}' unless defined(&atomic_subtract_acq_long);
	eval 'sub atomic_subtract_rel_long () {\'kcsan_atomic_subtract_rel_long\';}' unless defined(&atomic_subtract_rel_long);
	eval 'sub atomic_store_long () {\'kcsan_atomic_store_long\';}' unless defined(&atomic_store_long);
	eval 'sub atomic_store_rel_long () {\'kcsan_atomic_store_rel_long\';}' unless defined(&atomic_store_rel_long);
	eval 'sub atomic_swap_long () {\'kcsan_atomic_swap_long\';}' unless defined(&atomic_swap_long);
	eval 'sub atomic_testandclear_long () {\'kcsan_atomic_testandclear_long\';}' unless defined(&atomic_testandclear_long);
	eval 'sub atomic_testandset_long () {\'kcsan_atomic_testandset_long\';}' unless defined(&atomic_testandset_long);
	eval 'sub atomic_testandset_acq_long () {\'kcsan_atomic_testandset_acq_long\';}' unless defined(&atomic_testandset_acq_long);
	eval 'sub atomic_add_ptr () { &kcsan_atomic_add_ptr;}' unless defined(&atomic_add_ptr);
	eval 'sub atomic_add_acq_ptr () { &kcsan_atomic_add_acq_ptr;}' unless defined(&atomic_add_acq_ptr);
	eval 'sub atomic_add_rel_ptr () { &kcsan_atomic_add_rel_ptr;}' unless defined(&atomic_add_rel_ptr);
	eval 'sub atomic_clear_ptr () { &kcsan_atomic_clear_ptr;}' unless defined(&atomic_clear_ptr);
	eval 'sub atomic_clear_acq_ptr () { &kcsan_atomic_clear_acq_ptr;}' unless defined(&atomic_clear_acq_ptr);
	eval 'sub atomic_clear_rel_ptr () { &kcsan_atomic_clear_rel_ptr;}' unless defined(&atomic_clear_rel_ptr);
	eval 'sub atomic_cmpset_ptr () { &kcsan_atomic_cmpset_ptr;}' unless defined(&atomic_cmpset_ptr);
	eval 'sub atomic_cmpset_acq_ptr () { &kcsan_atomic_cmpset_acq_ptr;}' unless defined(&atomic_cmpset_acq_ptr);
	eval 'sub atomic_cmpset_rel_ptr () { &kcsan_atomic_cmpset_rel_ptr;}' unless defined(&atomic_cmpset_rel_ptr);
	eval 'sub atomic_fcmpset_ptr () { &kcsan_atomic_fcmpset_ptr;}' unless defined(&atomic_fcmpset_ptr);
	eval 'sub atomic_fcmpset_acq_ptr () { &kcsan_atomic_fcmpset_acq_ptr;}' unless defined(&atomic_fcmpset_acq_ptr);
	eval 'sub atomic_fcmpset_rel_ptr () { &kcsan_atomic_fcmpset_rel_ptr;}' unless defined(&atomic_fcmpset_rel_ptr);
	eval 'sub atomic_fetchadd_ptr () { &kcsan_atomic_fetchadd_ptr;}' unless defined(&atomic_fetchadd_ptr);
	eval 'sub atomic_load_ptr {
	    my($x) = @_;
    	    eval q(({  &__typeof(*$x)  &__retptr;  &__retptr = ( &void *) &kcsan_atomic_load_ptr(( &volatile  &uintptr_t *)($x));  &__retptr; }));
	}' unless defined(&atomic_load_ptr);
	eval 'sub atomic_load_acq_ptr () { &kcsan_atomic_load_acq_ptr;}' unless defined(&atomic_load_acq_ptr);
	eval 'sub atomic_load_consume_ptr {
	    my($x) = @_;
    	    eval q(({  &__typeof(*$x)  &__retptr;  &__retptr = ( &void *) &kcsan_atomic_load_acq_ptr(( &volatile  &uintptr_t *)($x));  &__retptr; }));
	}' unless defined(&atomic_load_consume_ptr);
	eval 'sub atomic_readandclear_ptr () { &kcsan_atomic_readandclear_ptr;}' unless defined(&atomic_readandclear_ptr);
	eval 'sub atomic_set_ptr () { &kcsan_atomic_set_ptr;}' unless defined(&atomic_set_ptr);
	eval 'sub atomic_set_acq_ptr () { &kcsan_atomic_set_acq_ptr;}' unless defined(&atomic_set_acq_ptr);
	eval 'sub atomic_set_rel_ptr () { &kcsan_atomic_set_rel_ptr;}' unless defined(&atomic_set_rel_ptr);
	eval 'sub atomic_subtract_ptr () { &kcsan_atomic_subtract_ptr;}' unless defined(&atomic_subtract_ptr);
	eval 'sub atomic_subtract_acq_ptr () { &kcsan_atomic_subtract_acq_ptr;}' unless defined(&atomic_subtract_acq_ptr);
	eval 'sub atomic_subtract_rel_ptr () { &kcsan_atomic_subtract_rel_ptr;}' unless defined(&atomic_subtract_rel_ptr);
	eval 'sub atomic_store_ptr {
	    my($x, $v) = @_;
    	    eval q(({  &__typeof(*$x)  &__value = ($v);  &kcsan_atomic_store_ptr(( &volatile  &uintptr_t *)($x), ( &uintptr_t)( &__value));}));
	}' unless defined(&atomic_store_ptr);
	eval 'sub atomic_store_rel_ptr () { &kcsan_atomic_store_rel_ptr;}' unless defined(&atomic_store_rel_ptr);
	eval 'sub atomic_swap_ptr () { &kcsan_atomic_swap_ptr;}' unless defined(&atomic_swap_ptr);
	eval 'sub atomic_testandclear_ptr () { &kcsan_atomic_testandclear_ptr;}' unless defined(&atomic_testandclear_ptr);
	eval 'sub atomic_testandset_ptr () { &kcsan_atomic_testandset_ptr;}' unless defined(&atomic_testandset_ptr);
	eval 'sub atomic_add_8 () { &kcsan_atomic_add_8;}' unless defined(&atomic_add_8);
	eval 'sub atomic_add_acq_8 () { &kcsan_atomic_add_acq_8;}' unless defined(&atomic_add_acq_8);
	eval 'sub atomic_add_rel_8 () { &kcsan_atomic_add_rel_8;}' unless defined(&atomic_add_rel_8);
	eval 'sub atomic_clear_8 () { &kcsan_atomic_clear_8;}' unless defined(&atomic_clear_8);
	eval 'sub atomic_clear_acq_8 () { &kcsan_atomic_clear_acq_8;}' unless defined(&atomic_clear_acq_8);
	eval 'sub atomic_clear_rel_8 () { &kcsan_atomic_clear_rel_8;}' unless defined(&atomic_clear_rel_8);
	eval 'sub atomic_cmpset_8 () { &kcsan_atomic_cmpset_8;}' unless defined(&atomic_cmpset_8);
	eval 'sub atomic_cmpset_acq_8 () { &kcsan_atomic_cmpset_acq_8;}' unless defined(&atomic_cmpset_acq_8);
	eval 'sub atomic_cmpset_rel_8 () { &kcsan_atomic_cmpset_rel_8;}' unless defined(&atomic_cmpset_rel_8);
	eval 'sub atomic_fcmpset_8 () { &kcsan_atomic_fcmpset_8;}' unless defined(&atomic_fcmpset_8);
	eval 'sub atomic_fcmpset_acq_8 () { &kcsan_atomic_fcmpset_acq_8;}' unless defined(&atomic_fcmpset_acq_8);
	eval 'sub atomic_fcmpset_rel_8 () { &kcsan_atomic_fcmpset_rel_8;}' unless defined(&atomic_fcmpset_rel_8);
	eval 'sub atomic_fetchadd_8 () { &kcsan_atomic_fetchadd_8;}' unless defined(&atomic_fetchadd_8);
	eval 'sub atomic_load_8 () { &kcsan_atomic_load_8;}' unless defined(&atomic_load_8);
	eval 'sub atomic_load_acq_8 () { &kcsan_atomic_load_acq_8;}' unless defined(&atomic_load_acq_8);
	eval 'sub atomic_readandclear_8 () { &kcsan_atomic_readandclear_8;}' unless defined(&atomic_readandclear_8);
	eval 'sub atomic_set_8 () { &kcsan_atomic_set_8;}' unless defined(&atomic_set_8);
	eval 'sub atomic_set_acq_8 () { &kcsan_atomic_set_acq_8;}' unless defined(&atomic_set_acq_8);
	eval 'sub atomic_set_rel_8 () { &kcsan_atomic_set_rel_8;}' unless defined(&atomic_set_rel_8);
	eval 'sub atomic_subtract_8 () { &kcsan_atomic_subtract_8;}' unless defined(&atomic_subtract_8);
	eval 'sub atomic_subtract_acq_8 () { &kcsan_atomic_subtract_acq_8;}' unless defined(&atomic_subtract_acq_8);
	eval 'sub atomic_subtract_rel_8 () { &kcsan_atomic_subtract_rel_8;}' unless defined(&atomic_subtract_rel_8);
	eval 'sub atomic_store_8 () { &kcsan_atomic_store_8;}' unless defined(&atomic_store_8);
	eval 'sub atomic_store_rel_8 () { &kcsan_atomic_store_rel_8;}' unless defined(&atomic_store_rel_8);
	eval 'sub atomic_swap_8 () { &kcsan_atomic_swap_8;}' unless defined(&atomic_swap_8);
	eval 'sub atomic_testandclear_8 () { &kcsan_atomic_testandclear_8;}' unless defined(&atomic_testandclear_8);
	eval 'sub atomic_testandset_8 () { &kcsan_atomic_testandset_8;}' unless defined(&atomic_testandset_8);
	eval 'sub atomic_add_16 () { &kcsan_atomic_add_16;}' unless defined(&atomic_add_16);
	eval 'sub atomic_add_acq_16 () { &kcsan_atomic_add_acq_16;}' unless defined(&atomic_add_acq_16);
	eval 'sub atomic_add_rel_16 () { &kcsan_atomic_add_rel_16;}' unless defined(&atomic_add_rel_16);
	eval 'sub atomic_clear_16 () { &kcsan_atomic_clear_16;}' unless defined(&atomic_clear_16);
	eval 'sub atomic_clear_acq_16 () { &kcsan_atomic_clear_acq_16;}' unless defined(&atomic_clear_acq_16);
	eval 'sub atomic_clear_rel_16 () { &kcsan_atomic_clear_rel_16;}' unless defined(&atomic_clear_rel_16);
	eval 'sub atomic_cmpset_16 () { &kcsan_atomic_cmpset_16;}' unless defined(&atomic_cmpset_16);
	eval 'sub atomic_cmpset_acq_16 () { &kcsan_atomic_cmpset_acq_16;}' unless defined(&atomic_cmpset_acq_16);
	eval 'sub atomic_cmpset_rel_16 () { &kcsan_atomic_cmpset_rel_16;}' unless defined(&atomic_cmpset_rel_16);
	eval 'sub atomic_fcmpset_16 () { &kcsan_atomic_fcmpset_16;}' unless defined(&atomic_fcmpset_16);
	eval 'sub atomic_fcmpset_acq_16 () { &kcsan_atomic_fcmpset_acq_16;}' unless defined(&atomic_fcmpset_acq_16);
	eval 'sub atomic_fcmpset_rel_16 () { &kcsan_atomic_fcmpset_rel_16;}' unless defined(&atomic_fcmpset_rel_16);
	eval 'sub atomic_fetchadd_16 () { &kcsan_atomic_fetchadd_16;}' unless defined(&atomic_fetchadd_16);
	eval 'sub atomic_load_16 () { &kcsan_atomic_load_16;}' unless defined(&atomic_load_16);
	eval 'sub atomic_load_acq_16 () { &kcsan_atomic_load_acq_16;}' unless defined(&atomic_load_acq_16);
	eval 'sub atomic_readandclear_16 () { &kcsan_atomic_readandclear_16;}' unless defined(&atomic_readandclear_16);
	eval 'sub atomic_set_16 () { &kcsan_atomic_set_16;}' unless defined(&atomic_set_16);
	eval 'sub atomic_set_acq_16 () { &kcsan_atomic_set_acq_16;}' unless defined(&atomic_set_acq_16);
	eval 'sub atomic_set_rel_16 () { &kcsan_atomic_set_rel_16;}' unless defined(&atomic_set_rel_16);
	eval 'sub atomic_subtract_16 () { &kcsan_atomic_subtract_16;}' unless defined(&atomic_subtract_16);
	eval 'sub atomic_subtract_acq_16 () { &kcsan_atomic_subtract_acq_16;}' unless defined(&atomic_subtract_acq_16);
	eval 'sub atomic_subtract_rel_16 () { &kcsan_atomic_subtract_rel_16;}' unless defined(&atomic_subtract_rel_16);
	eval 'sub atomic_store_16 () { &kcsan_atomic_store_16;}' unless defined(&atomic_store_16);
	eval 'sub atomic_store_rel_16 () { &kcsan_atomic_store_rel_16;}' unless defined(&atomic_store_rel_16);
	eval 'sub atomic_swap_16 () { &kcsan_atomic_swap_16;}' unless defined(&atomic_swap_16);
	eval 'sub atomic_testandclear_16 () { &kcsan_atomic_testandclear_16;}' unless defined(&atomic_testandclear_16);
	eval 'sub atomic_testandset_16 () { &kcsan_atomic_testandset_16;}' unless defined(&atomic_testandset_16);
	eval 'sub atomic_add_32 () { &kcsan_atomic_add_32;}' unless defined(&atomic_add_32);
	eval 'sub atomic_add_acq_32 () { &kcsan_atomic_add_acq_32;}' unless defined(&atomic_add_acq_32);
	eval 'sub atomic_add_rel_32 () { &kcsan_atomic_add_rel_32;}' unless defined(&atomic_add_rel_32);
	eval 'sub atomic_clear_32 () { &kcsan_atomic_clear_32;}' unless defined(&atomic_clear_32);
	eval 'sub atomic_clear_acq_32 () { &kcsan_atomic_clear_acq_32;}' unless defined(&atomic_clear_acq_32);
	eval 'sub atomic_clear_rel_32 () { &kcsan_atomic_clear_rel_32;}' unless defined(&atomic_clear_rel_32);
	eval 'sub atomic_cmpset_32 () { &kcsan_atomic_cmpset_32;}' unless defined(&atomic_cmpset_32);
	eval 'sub atomic_cmpset_acq_32 () { &kcsan_atomic_cmpset_acq_32;}' unless defined(&atomic_cmpset_acq_32);
	eval 'sub atomic_cmpset_rel_32 () { &kcsan_atomic_cmpset_rel_32;}' unless defined(&atomic_cmpset_rel_32);
	eval 'sub atomic_fcmpset_32 () { &kcsan_atomic_fcmpset_32;}' unless defined(&atomic_fcmpset_32);
	eval 'sub atomic_fcmpset_acq_32 () { &kcsan_atomic_fcmpset_acq_32;}' unless defined(&atomic_fcmpset_acq_32);
	eval 'sub atomic_fcmpset_rel_32 () { &kcsan_atomic_fcmpset_rel_32;}' unless defined(&atomic_fcmpset_rel_32);
	eval 'sub atomic_fetchadd_32 () { &kcsan_atomic_fetchadd_32;}' unless defined(&atomic_fetchadd_32);
	eval 'sub atomic_load_32 () { &kcsan_atomic_load_32;}' unless defined(&atomic_load_32);
	eval 'sub atomic_load_acq_32 () { &kcsan_atomic_load_acq_32;}' unless defined(&atomic_load_acq_32);
	eval 'sub atomic_readandclear_32 () { &kcsan_atomic_readandclear_32;}' unless defined(&atomic_readandclear_32);
	eval 'sub atomic_set_32 () { &kcsan_atomic_set_32;}' unless defined(&atomic_set_32);
	eval 'sub atomic_set_acq_32 () { &kcsan_atomic_set_acq_32;}' unless defined(&atomic_set_acq_32);
	eval 'sub atomic_set_rel_32 () { &kcsan_atomic_set_rel_32;}' unless defined(&atomic_set_rel_32);
	eval 'sub atomic_subtract_32 () { &kcsan_atomic_subtract_32;}' unless defined(&atomic_subtract_32);
	eval 'sub atomic_subtract_acq_32 () { &kcsan_atomic_subtract_acq_32;}' unless defined(&atomic_subtract_acq_32);
	eval 'sub atomic_subtract_rel_32 () { &kcsan_atomic_subtract_rel_32;}' unless defined(&atomic_subtract_rel_32);
	eval 'sub atomic_store_32 () { &kcsan_atomic_store_32;}' unless defined(&atomic_store_32);
	eval 'sub atomic_store_rel_32 () { &kcsan_atomic_store_rel_32;}' unless defined(&atomic_store_rel_32);
	eval 'sub atomic_swap_32 () { &kcsan_atomic_swap_32;}' unless defined(&atomic_swap_32);
	eval 'sub atomic_testandclear_32 () { &kcsan_atomic_testandclear_32;}' unless defined(&atomic_testandclear_32);
	eval 'sub atomic_testandset_32 () { &kcsan_atomic_testandset_32;}' unless defined(&atomic_testandset_32);
	eval 'sub atomic_add_64 () { &kcsan_atomic_add_64;}' unless defined(&atomic_add_64);
	eval 'sub atomic_add_acq_64 () { &kcsan_atomic_add_acq_64;}' unless defined(&atomic_add_acq_64);
	eval 'sub atomic_add_rel_64 () { &kcsan_atomic_add_rel_64;}' unless defined(&atomic_add_rel_64);
	eval 'sub atomic_clear_64 () { &kcsan_atomic_clear_64;}' unless defined(&atomic_clear_64);
	eval 'sub atomic_clear_acq_64 () { &kcsan_atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_64);
	eval 'sub atomic_clear_rel_64 () { &kcsan_atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_64);
	eval 'sub atomic_cmpset_64 () { &kcsan_atomic_cmpset_64;}' unless defined(&atomic_cmpset_64);
	eval 'sub atomic_cmpset_acq_64 () { &kcsan_atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_acq_64);
	eval 'sub atomic_cmpset_rel_64 () { &kcsan_atomic_cmpset_rel_64;}' unless defined(&atomic_cmpset_rel_64);
	eval 'sub atomic_fcmpset_64 () { &kcsan_atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_64);
	eval 'sub atomic_fcmpset_acq_64 () { &kcsan_atomic_fcmpset_acq_64;}' unless defined(&atomic_fcmpset_acq_64);
	eval 'sub atomic_fcmpset_rel_64 () { &kcsan_atomic_fcmpset_rel_64;}' unless defined(&atomic_fcmpset_rel_64);
	eval 'sub atomic_fetchadd_64 () { &kcsan_atomic_fetchadd_64;}' unless defined(&atomic_fetchadd_64);
	eval 'sub atomic_load_64 () { &kcsan_atomic_load_64;}' unless defined(&atomic_load_64);
	eval 'sub atomic_load_acq_64 () { &kcsan_atomic_load_acq_64;}' unless defined(&atomic_load_acq_64);
	eval 'sub atomic_readandclear_64 () { &kcsan_atomic_readandclear_64;}' unless defined(&atomic_readandclear_64);
	eval 'sub atomic_set_64 () { &kcsan_atomic_set_64;}' unless defined(&atomic_set_64);
	eval 'sub atomic_set_acq_64 () { &kcsan_atomic_set_acq_64;}' unless defined(&atomic_set_acq_64);
	eval 'sub atomic_set_rel_64 () { &kcsan_atomic_set_rel_64;}' unless defined(&atomic_set_rel_64);
	eval 'sub atomic_subtract_64 () { &kcsan_atomic_subtract_64;}' unless defined(&atomic_subtract_64);
	eval 'sub atomic_subtract_acq_64 () { &kcsan_atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_64);
	eval 'sub atomic_subtract_rel_64 () { &kcsan_atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_64);
	eval 'sub atomic_store_64 () { &kcsan_atomic_store_64;}' unless defined(&atomic_store_64);
	eval 'sub atomic_store_rel_64 () { &kcsan_atomic_store_rel_64;}' unless defined(&atomic_store_rel_64);
	eval 'sub atomic_swap_64 () { &kcsan_atomic_swap_64;}' unless defined(&atomic_swap_64);
	eval 'sub atomic_testandclear_64 () { &kcsan_atomic_testandclear_64;}' unless defined(&atomic_testandclear_64);
	eval 'sub atomic_testandset_64 () { &kcsan_atomic_testandset_64;}' unless defined(&atomic_testandset_64);
	eval 'sub atomic_thread_fence_acq () { &kcsan_atomic_thread_fence_acq;}' unless defined(&atomic_thread_fence_acq);
	eval 'sub atomic_thread_fence_acq_rel () { &kcsan_atomic_thread_fence_acq_rel;}' unless defined(&atomic_thread_fence_acq_rel);
	eval 'sub atomic_thread_fence_rel () { &kcsan_atomic_thread_fence_rel;}' unless defined(&atomic_thread_fence_rel);
	eval 'sub atomic_thread_fence_seq_cst () { &kcsan_atomic_thread_fence_seq_cst;}' unless defined(&atomic_thread_fence_seq_cst);
	eval 'sub atomic_interrupt_fence () { &__compiler_membar;}' unless defined(&atomic_interrupt_fence);
    }
}
1;
